#!/bin/sh
#
#Script para init.d, para copiar la copia de seguridad de /home/garraxi2/backups
# de un ordenata al otro (copias cruzadas). Se instala en aux:/etc/init.d y se arranca
# en el inicio. El cruce lo hace de la siguiente forma:
# 1. Monta el dir de backup del server en el aux.
# 2. Hace las copias cruzadas con cpbk.
# 3. Desmonta el dir de bacup.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#########

#Check if cpbk exists, if not do nothing:
#Oh!, these scripts are sooo ugly, make a better ones :-D.
test -x /usr/bin/cpbk || echo "El programa Backup Copy no esta instalado!!"
test -x /usr/bin/cpbk || exit 0

#Cruzar las copias de seguridad:
echo "Arrancando el cruce de copias de seguridad..."

mkdir /tmp/backups-server;
mount -t nfs -o user,auto,rsize=8192,wsize=8192,timeo=14,intr 192.168.0.1:/home/garraxi2/backups /tmp/backups-server;

cpbk -q /tmp/backups-server/server /home/garraxi2/backups/server;
cpbk -q /home/garraxi2/backups/aux /tmp/backups-server/aux;

umount /tmp/backups-server;
rmdir /tmp/backups-server;

echo "Cruce de copias de seguridad realizado O.K."

exit 0
