#!/bin/sh
#Interfaz Xdialog para "proteger" (pasar a owned garraxi2) los archivos y subdirs de /Musica y /Kunuyas.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Para comprobar que es garraxi2 el que ejecuta el script (si no es exit, si es continua...):
QUIENSOY=`whoami`;
if [ "$QUIENSOY" != "garraxi2" ];then
Xdialog --wmclass "soma" --title "Usuario no autorizado" --icon /usr/local/share/pixmaps/warning.xpm \
        --msgbox "Me parece que tu no eres el Administrador de la Emisin.\nAbortando..." 0 0;
exit;
fi

# Funcion que elige el directorio:
directorio()
{
    DIR=`Xdialog --wmclass "soma" --title "Proteger msica/kuas"  --no-buttons --stdout \
       --backtitle "Elige la carpeta que quieres proteger (solo se puede una).\nSi eliges toda la carpeta /Musica le costar mas tiempo." \
        --dselect /home/garraxi/Biltegi 0 0`;
    case $? in
    0)	
    echo "$DIR" | grep "/home/garraxi/Biltegi"
    ;;
    1)
    exit;;
    esac   
}

# Funcion que hace el "trabajpo sucio" y presenta los resultados (solo informa de los cambios en chown):
curra()
{
  sudo chown -R -v garraxi2:garraxi2 "$DIR" > /tmp/garraxi2-chown.log &
  Xdialog --title "Resultados proteccin" --smooth --no-cancel --wmclass "soma" \
          --backtitle "Explicacin de los resultados:\n\"...permanece como garraxi2:garraxi2\" -> el archivo ya estaba protegido.\n\"cambiado el propietario de...\" -> la proteccin ha sido un xito.\nCualquier otro resultado: infrmame (martintxo@sindominio.net)" \
           --tailbox /tmp/garraxi2-chown.log 25 100;
#No se pueden "proteger" los propios dir /Musica y /Kunyas, porque si no no se podria grabar nada en ellos. Tampoco /Programas (ni ningun archivo dentro de el) ni el propio /Biltegi.
  sudo chown garraxi:garraxi /home/garraxi/Biltegi/Musica;
  sudo chown garraxi:garraxi /home/garraxi/Biltegi/Kunyas;
  sudo chown garraxi:garraxi /home/garraxi/Biltegi/Kunyas/kunyas;
  sudo chown garraxi:garraxi /home/garraxi/Biltegi/Kunyas/jingles;
  sudo chown garraxi:garraxi "/home/garraxi/Biltegi/Kunyas/kuas emitidas";
  sudo chown -R garraxi:garraxi /home/garraxi/Biltegi/Programas;
  sudo chown garraxi:garraxi /home/garraxi/Biltegi;
#Tampoco se puede "proteger" el de novedades, ni el de rippeado (ni su contenido):  
  sudo chown garraxi:garraxi /home/garraxi/Biltegi/Musica/!NOVEDADES;
  sudo chown -R garraxi:garraxi /home/garraxi/Biltegi/Musica/!RIPPEADO;
#Fija los permisos de los archivos a rw-r--r--, y de los dir a rwxr-xr-x. Solo en el caso de que los archivos ya fueran ejecutables (pasa cuando se copian archivos de dispositivos fat como disquetes o memorias usb) estos se mantienen ejecutables (rwx-r-xr-x).
  sudo chmod -R u=rwX,go=rX "$DIR";
  rm -f /tmp/garraxi2-chown.log
}

#Pregunta inicial de si proteger musica o no:
Xdialog --wmclass "soma" --title "Proteger msica/kuas" --left \
        --backtitle "Quieres proteger la msica y/o cuas de la Garraxi?" \
       --yesno "Antes de hacerlo, mira un poco cuantas carpetas hay sin proteger,\ny si hay duplicados, o msica mal grabada...\nDespus, en la siguiente ventana, elige la carpeta Kunyas o Musica\n(segn corresponda) y la subcarpeta que quieras proteger." 0 0

#Si respuesta es SI: elegir directorios, protegerlos, sacar output en pantalla
#Si respuesta es NO: sale sin hacer nada
case $? in
  0)
     directorio
        #Si el dir elegido esta en el path permitido, curra, si no mensaje:
	  if [ $? -eq 0 ];then
          curra
          else
          Xdialog --wmclass "soma" --title "Proteger msica/kuas" --icon /usr/local/share/pixmaps/warning.xpm \
                  --msgbox "Creo que te has equivocado y has elegido una carpeta no permitida.\nVuelve a intentarlo..." 0 0;
                   directorio
		     if [ $? -eq 0 ];then
                       curra
                     else
		       Xdialog --wmclass "soma" --title "Proteger msica/kuas" --icon /usr/local/share/pixmaps/warning.xpm \
                               --msgbox "Es la 2 vez que te \"equivocas\".\nAbortando..." 0 0;
		       exit;
		     fi
          fi
;;
  1)
    exit;;
esac
