#!/bin/sh
#interfaz Xdialog para arrancar flrec, grabar desde mesa mezclas y
# guardar el output en el ordenata como ogg (PARA CUAS)
#Utiliza flrec/sox para la grabacion, di para el uso del disco, bc para calcular el espacio en disco,
# y vorbiscomment para meter comentarios en el ogg.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variables utiles (paths y tal):
#DIRKUNYAS=/home/martintxo/pruebas
DIRKUNYAS=/home/garraxi/Biltegi/Kunyas/kunyas
DIRTEMP=/tmp
#DIPATH=/dev/hda1
DIPATH=/home/garraxi/Biltegi/Kunyas

#Variable que guarda informacion sobre espacio libre en disco:
# Con df problema: segun baja el tamao disponible, cambia el output de df y cut puede no encontrar el valor
# solucion: utilizar di (pero hace honor a LANG y da decimales separados por comas, y eso no gusta a bc)
DISCO="`export LANG=en; di -f v -n -m -w 0 $DIPATH; export LANG=es_ES`"

#Con la tasa de bits a la que grabamos con flrec/sox (90 kb/s) una hora ocupa aprox 30 Mb.
#Por lo que en sdc1 (8.624Mb) pueden llegar a caber unas 280 horas de cuas.
HORAS=$(echo "scale=1; $DISCO/30" | bc)

#GUI para dar el nombre del archivo donde se graba:
GUI=`Xdialog --wmclass "grabar" --title "Grabar CUAS" \
        --backtitle "En el disco duro donde se guardan las cuas (sdc1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacin." \
	--stdout --left --separator "|" \
	--inputbox "Escribe un nombre descriptivo para la CUA.\n * Ejemplo: Manifa_presos-5_feb_2006\n * Utiliza un nombre sencillo, con pocas palabras, y sin letras raras ( \"'s\" ), NI ESPACIOS.\n * El archivo se guarda en ~/Biltegi/Kunyas/kunyas/.\n    NO LO MUEVAS DE AH (es la carpeta desde la que se emiten automticamente).\n * Si crees que hay poco espacio para grabar cuas (lo dice aqu arriba)\n    considera el sacar del ordenata alguna de las cuas (comntalo en la asamblea).\n         -------------------\n * Tras dar al OK te aparecer la ventana del programa grabador.\n * Haz click en el botn pequeo que hay encima del que tiene un crculo rojo.\n * Despus haz click en el botn del crculo rojo y EMPEZAR A GRABAR.\n         -------------------\n * Cuando acabes de grabar haz click en el botn del cuadrado verde (finaliza la grabacin).\n * Despus cierra el programa con la \"x\" de arriba a la derecha.\n * Aparecer una ventana informativa similar a esta, sigue sus instrucciones.\nGracias :-D!!." 0 0 "" `

#Variable para meter la fecha de la cua en los comentarios del ogg:
DATE=`date +%d/%m/%Y_%H:%M:%S`;

#Cuando NO se rellena la casilla, sale sin decir nada (igual si se cancela):
if [ "$GUI" = "" ];then
  exit;
fi

#Cuando el fichero que queremos grabar ya existe de antes, da mensaje de error y arranca de nuevo el programa:
if  test -f "$DIRKUNYAS/$GUI.ogg";then
 Xdialog --wmclass "grabar" --title "Grabar CUAS" \
	--infobox "OOOPS!!\nEl nombre de la cua que has elegido ya existe.\nIntentalo de nuevo con otro nombre." 0 0 5000;
 exec flrec-grabacunya.sh;
fi

#Cuando SI se rellena la casilla, arranca el flrec con las opciones adecuadas, listo para grabar:
#Graba la cua en dir /tmp para que no exista durante su grabacion y asi un Somad arrancado no pueda
# comenzar a emitir la cua que se esta grabando en ese momento.
#Esto solo era imp. para programas, pero implementado tb. para cuas porsia :-D.
if [ "$GUI" != "" ];then
  flrec -q "$DIRTEMP/$GUI.ogg";
  vorbiscomment -a -t "TITLE=Cunya \"$GUI\", grabada el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -t "ARTIST=Realizador@s de \"$GUI\"" -t "DATE=$DATE" -t "COPYRIGHT=Las personas que han grabado la cunya \"$GUI\"" -t "LICENSE=Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-NoComercial-CompartirIgual\": http://creativecommons.org/licenses/by-nc-sa/2.5/es/" -t "ORGANIZATION=Garraxi Irratia" -t "CONTACT=http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI.ogg"
#Al finalizar la grabacion, mueve el archivo grabado al lugar adecuado:   
  mv "$DIRTEMP/$GUI.ogg" "$DIRKUNYAS/$GUI.ogg";

#GUI con la info final:
Xdialog --wmclass "soma" --title "Grabar CUAS" --ok-label "FIN" --left \
        --msgbox "          BIEEEN :-D!!.\nHas terminado de grabar la cua.\nAhora, si quieres que esa cua est disponible para su emisin,\n   haz doble click sobre el cono de abajo a la izquierda del escritorio\n   que sirve para que Somad relea los archivos que tiene para emitir y se entere de los cambios.\nGracias :-D!!" 0 0;
fi
