#!/bin/sh
#interfaz Xdialog para arrancar flrec, grabar desde mesa mezclas y
# guardar el output en el ordenata como ogg (PARA PROGRAMAS).
#Utiliza flrec/sox para la grabacion, di para el uso del disco, bc para calcular el espacio en disco,
# fdupes para buscar archivos duplicados y vorbiscomment para meter comentarios en el ogg.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variables utiles (paths y tal):
#DIRPROGRAMAS=/home/martintxo/pruebas
DIRPROGRAMAS=/home/garraxi/Biltegi/Programas
DIRTEMP=/tmp
#LISTAPROGRAMAS=/home/martintxo/pruebas/programas.txt
LISTAPROGRAMAS=/home/garraxi/.programas-radio/programas.txt
#DIPATH=/dev/hda1
DIPATH=/home/garraxi/Biltegi/Programas

###################
# Funcion para si se elige meter el nombre a mano::
amano()
{
#GUI para meter a mano el nombre del archivo donde se graba:
GUI=`Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
        --backtitle "En el disco duro donde se guardan los Programas (sdb1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacin." \
	--stdout --left --separator "|" \
	--check "Guardar otro programa que pueda existir con igual nombre" "on" \
	--inputbox "Introduce un nombre descriptivo para el programa que vas a grabar.\n * Ejemplo: Programa_especial_Nochevieja2006.\n * Utiliza un nombre sencillo, con pocas palabras, y sin letras raras ( \"'s\" ), NI ESPACIOS.\n * El archivo se guarda en ~/Biltegi/Programas/Nombre_programa.ogg.\n    ES MEJOR QUE NO LO MUEVAS DE AH.\n * Selecciona botn \"Guardar...\", para guardar otro programa que pudiera haber con el MISMO nombre.\n    Se guardara en una subcarpeta aadiendo la fecha y la hora de grabacin al nombre del programa.\n * Controla el espacio libre del disco (arriba) y si queda poco, considera el borrar\n      o sacar del ordenata alguno de tus programas anteriores.\n         -------------------\n * Tras dar al OK te aparecer la ventana del programa grabador.\n * Haz click en el botn pequeo que hay encima del que tiene un crculo rojo.\n * Despus haz click en el botn del crculo rojo y EMPEZAR A GRABAR.\n         -------------------\n * Cuando acabes de grabar haz click en el botn del cuadrado verde (finaliza la grabacin).\n * Despus cierra el programa con la \"x\" de arriba a la derecha.\n * Aparecer una ventana informativa similar a esta, sigue sus instrucciones.\nGracias :-D!!." \
0 0 "" `
#Para que salga sin arrancar flrec, ni decir nada, si se presiona Cancelar:
STATUSRET=$?
if [ $STATUSRET -eq 1 ];then
	exit;
fi
#Lo mismo si se pincha el boton "cerrar programa" de Icewm:
if [ $STATUSRET -eq 255 ];then
	exit;
fi
#Quita a $GUI el output de --check que aparece despues de un espacio y puede ser checked o unchecked (para que no de errores):
GUI2=`echo $GUI | gawk --source '{ sub (/ checked/, ""); sub (/ unchecked/, ""); sub (/checked/, "");  sub (/unchecked/, ""); sub (/un/, ""); print }'`;
#Cuando NO se introduce nombre archivo, vuelve a aparecer el programa desde el principio:
if [ "$GUI2" = "" ];then
 Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
	--infobox "OOOPS!!\nParece que se te ha olvidado introducir un nombre de archivo.\nIntentalo de nuevo :-D..." 0 0 5000;
  exec flrec-grabaprograma.sh;
fi
}
###################

#Variable que lee los programas dados de alta desde el archivo de "configuracion":
PROGRAMAS="`echo "Selecciona_nombre..." && cat $LISTAPROGRAMAS && echo "Meter_nombre_a_mano_(en_otra_ventana)..."`"

#Variable que guarda informacion sobre espacio libre en disco:
# Con df problema: segun baja el tamao disponible, cambia el output de df y cut puede no encontrar el valor
# solucion: utilizar di (pero hace honor a LANG y da decimales separados por comas, y eso no gusta a bc)
DISCO="`export LANG=en; di -f v -n -m -w 0 $DIPATH; export LANG=es_ES`"

#Con la tasa de bits a la que grabamos con flrec/sox (90 kb/s) una hora ocupa aprox 30 Mb.
#Por lo que en sdb1 (17.654Mb) pueden llegar a caber unos 580 programas de 1 hora.
HORAS=$(echo "scale=1; $DISCO/30" | bc)

#GUI para seleccionar el nombre del archivo donde se graba:
GUI=`Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
        --backtitle "En el disco duro donde se guardan los Programas (sdb1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacin." \
	--stdout --left --separator "|" \
	--check "Guardar el archivo del programa anterior" "on" \
	--combobox "Selecciona el nombre de tu programa (el asignado en la parrilla).\n * Ejemplo: Saltsa_Berde\n * El archivo se guarda en ~/Biltegi/Programas/Nombre_programa.ogg.\n    NO LO MUEVAS DE AH (ni le cambies el nombre).\n    Solo si est en esa carpeta y tiene el nombre exacto se emitar automticamente.\n * Selecciona botn \"Guardar...\", para guardar el programa de la vez anterior.\n    Se guarda en una subcarpeta aadiendo la fecha y la hora de grabacin al nombre del programa.\n * Controla el espacio libre del disco (arriba) y si queda poco, considera el borrar\n      o sacar del ordenata alguno de tus programas anteriores.\n         -------------------\n * Tras dar al OK te aparecer la ventana del programa grabador.\n * Haz click en el botn pequeo que hay encima del que tiene un crculo rojo.\n * Despus haz click en el botn del crculo rojo y EMPEZAR A GRABAR.\n         -------------------\n * Cuando acabes de grabar haz click en el botn del cuadrado verde (finaliza la grabacin).\n * Despus cierra el programa con la \"x\" de arriba a la derecha.\n * Aparecer una ventana informativa similar a esta, sigue sus instrucciones.\nGracias :-D!!." \
0 0 \
$PROGRAMAS"" `
	
#Para que salga sin arrancar flrec, ni decir nada, si se presiona Cancelar:
STATUSRET=$?
if [ $STATUSRET -eq 1 ];then
	exit;
fi
#Lo mismo si se pincha el boton "cerrar programa" de Icewm:
if [ $STATUSRET -eq 255 ];then
	exit;
fi

#Quita a $GUI el output de --check que aparece despues de un espacio y puede ser checked o unchecked (para que no de errores):
GUI2=`echo $GUI | gawk --source '{ sub (/ checked/, ""); sub (/ unchecked/, ""); sub (/checked/, "");  sub (/unchecked/, ""); sub (/un/, ""); print }'`;

#Cuando NO se selecciona bien la casilla, vuelve a aparecer el programa:
if [ "$GUI2" = "Selecciona_nombre..." ];then
 Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
	--infobox "OOOPS!!\nParece que te has equivocado al seleccionar un nombre de programa adecuado.\nIntentalo de nuevo :-D..." 0 0 5000;
  exec flrec-grabaprograma.sh;
fi

#Cuando se selecciona "meter nombre a mano" aparece otro cuadro de dialogo similar::
if [ "$GUI2" = "Meter_nombre_a_mano_(en_otra_ventana)..." ];then
   amano
fi

#Variable para meter la fecha del programa que vamos a grabar en los comentarios del ogg:
DATE=`date +%d/%m/%Y_%H:%M:%S`;

#Variables para obtener la fecha y la hora del programa anterior desde la fecha de ultimo acceso:
if  test -f "$DIRPROGRAMAS/$GUI2.ogg";then
DATEANT=`stat -c %x "$DIRPROGRAMAS/$GUI2.ogg" | cut --delimiter=" " -f 1 -s`;
HOURANT=`stat -c %x "$DIRPROGRAMAS/$GUI2.ogg" | cut --delimiter=" " -f 2 -s | cut -c '-8'`;
fi

#Cuando SI se selecciona bien la casilla (es igual si se viene desde el "a mano")...
if [ "$GUI2" != "Selecciona_nombre..." ];then

#Busca duplicados y si los encuentra, guarda su path/nombre en duplicados.txt:
touch $DIRTEMP/duplicados.txt
for i in `fdupes -n -1 -r -q $DIRPROGRAMAS`
do 
 DUPLIC=`echo $i | dirname $i`
  if [ "$DUPLIC" = "$DIRPROGRAMAS" ];then
   echo "$i" >> $DIRTEMP/duplicados.txt
  fi
done

#Parsea el output de --check para mover y renombrar o no el archivo anterior:
 for i in $GUI ; do
     case $i in
 	checked)
          if  test -f "$DIRPROGRAMAS/$GUI2.ogg" ;then
             #Si el archivo de programa a mover no esta duplicado lo backupea:
             cat $DIRTEMP/duplicados.txt | grep "$GUI2" > /dev/null
             if [ $? -eq 1 ];then
                install -d "$DIRPROGRAMAS/$GUI2" && mv "$DIRPROGRAMAS/$GUI2.ogg" "$DIRPROGRAMAS/$GUI2/$GUI2-$DATEANT-$HOURANT.ogg"
	     else
	     #Si el ogg esta duplicado lo borra:
	        rm "$DIRPROGRAMAS/$GUI2.ogg"
             fi
          fi
          ;;
     esac
 done
 for i in $GUI ; do
     case $i in
        unchecked)
 	   rm "$DIRPROGRAMAS/$GUI2.ogg"
	   ;;
     esac
 done
 
#Borra archivo de duplicados:
rm $DIRTEMP/duplicados.txt

#Arranca el flrec con las opciones adecuadas, listo para grabar:
#Graba el programa en dir /tmp para que no exista durante su grabacion y asi un Somad arrancado no pueda
# comenzar a emitir el programa que se esta grabando en ese momento.
  flrec -q "$DIRTEMP/$GUI2.ogg";
  vorbiscomment -a -t "TITLE=Programa \"$GUI2\", grabado el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -t "ARTIST=Realizador@s de \"$GUI2\"" -t "DATE=$DATE" -t "COPYRIGHT=Las personas que hacen el programa \"$GUI2\"" -t "LICENSE=Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-NoComercial-CompartirIgual\": http://creativecommons.org/licenses/by-nc-sa/2.5/es/" -t "ORGANIZATION=Garraxi Irratia" -t "CONTACT=http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI2.ogg"
#Al finalizar la grabacion, mueve el archivo grabado al lugar adecuado:   
  mv "$DIRTEMP/$GUI2.ogg" "$DIRPROGRAMAS/$GUI2.ogg";
  
#GUI con la info final:
Xdialog --wmclass "soma" --title "Grabar PROGRAMAS" --ok-label "FIN" --left \
        --msgbox "          BIEEEN :-D!!.\nHas terminado de grabar tu programa.\nRecuerda que para que tu programa se re-emita automticamente\n   tiene que estar \"dado de alta\" en la parrilla de Somad.\n   Si no lo est, comntalo en la asamblea o dselo a alguien de Garraxi.\nGracias :-D!!" 0 0;
fi
