#!/bin/sh
# Script para presentar la info de archivos ogg, mp3 y wav
# Utiliza file, ogginfo (del paquete vorbis-tools), eyed3 e InfoWave (waveutils: http://billposer.org/software.html)
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variable que recoge los archivos seleccionados
SELECCIONADO=$*

#Si queremos encerrar el nombre del archivo entre comillas (no necesario)
#SELECCIONADO2=`echo -e \'$SELECCIONADO\'`;

#Variable para determinar si es mp3, ogg o wav:
PARSER=`file -i -b "$SELECCIONADO"`;

#Si es ogg:
if [ "$PARSER" = "application/ogg" ];then
  ogginfo "$SELECCIONADO" | Xdialog --wmclass "soma" --title "ogg/mp3/wav info" \
    --no-cancel --backtitle "Informacin del archivo OGG \"$SELECCIONADO\":" --tailbox - 20 70;
   exit;
fi

#Si es mp3 (mimetype standar):
if [ "$PARSER" = "audio/mpeg" ];then
    eyeD3 --no-color "$SELECCIONADO" | Xdialog --wmclass "soma" --title "ogg/mp3/wav info" \
    --no-cancel --backtitle "Informacin del archivo MP3 \"$SELECCIONADO\":" --textbox - 20 70;
   exit;
fi
#Otras posiblidades para el script:
# eyeD3 --no-color "$SELECCIONADO" | Xdialog --wmclass "soma" --title "ogg/mp3 info" \
#    --no-cancel --fixed-font --backtitle "Informacin del archivo MP3:" --textbox - 18 90
#  mp3info -x "$SELECCIONADO" |

#Si es mp3 (mimetype utilizado por la version2 de mp3?):
if [ "$PARSER" = "application/octet-stream" ];then
    eyeD3 --no-color "$SELECCIONADO" | Xdialog --wmclass "soma" --title "ogg/mp3/wav info" \
    --no-cancel --backtitle "Informacin del archivo MP3 \"$SELECCIONADO\":" --textbox - 20 70;
   exit;
fi

#Si es wav:
if [ "$PARSER" = "audio/x-wav" ];then
    InfoWave "$SELECCIONADO" | Xdialog --wmclass "soma" --title "ogg/mp3/wav info" \
    --no-cancel --backtitle "Informacin del archivo WAV \"$SELECCIONADO\":" --textbox - 20 70;
   exit;
fi

#En caso de no reconocer el archivo, presenta la info de file:
file "$SELECCIONADO" | Xdialog --wmclass "soma" --title "ogg/mp3/wav info" \
    --no-cancel --backtitle "Informacin de archivo no reconocido \"$SELECCIONADO\":" --textbox - 0 0;
